from iwla import IWLA
from iplugin import IPlugin

class IWLAPostAnalysisTopVisitors(IPlugin):
    def __init__(self, iwla):
        super(IWLAPostAnalysisTopVisitors, self).__init__(iwla)
        self.API_VERSION = 1

    def hook(self, iwla):
        hits = iwla.getValidVisitors()
        stats = iwla.getMonthStats()
        top_bandwidth = [(k,hits[k]['bandwidth']) for k in hits.keys()]
        top_bandwidth = sorted(top_bandwidth, key=lambda t: t[1], reverse=True)
        stats['top_visitors'] = [hits[h[0]] for h in top_bandwidth[:10]]

