import re

from iwla import IWLA
from iplugin import IPlugin

import awstats_data

class IWLAPreAnalysisRobots(IPlugin):
    def __init__(self, iwla):
        super(IWLAPreAnalysisRobots, self).__init__(iwla)
        self.API_VERSION = 1

    def load(self):
        self.awstats_robots = map(lambda (x) : re.compile(x, re.IGNORECASE), awstats_data.robots)
    
        return True

# Basic rule to detect robots
    def hook(self, iwla):
        hits = iwla.getCurrentVisists()
        for k in hits.keys():
            super_hit = hits[k]

            if super_hit['robot']: continue

            isRobot = False
            referers = 0

            first_page = super_hit['requests'][0]
            if first_page['time_decoded'].tm_mday == super_hit['last_access'].tm_mday:
                for r in self.awstats_robots:
                    if r.match(first_page['http_user_agent']):
                        isRobot = True
                        break

                if isRobot:
                    super_hit['robot'] = 1
                    continue

# 1) no pages view --> robot
            # if not super_hit['viewed_pages']:
            #     super_hit['robot'] = 1
            #     continue

# 2) pages without hit --> robot
            if not super_hit['viewed_hits']:
                super_hit['robot'] = 1
                continue

            for hit in super_hit['requests']:
# 3) /robots.txt read
                if hit['extract_request']['http_uri'] == '/robots.txt':
                    isRobot = True
                    break

# 4) Any referer for hits
                if not hit['is_page'] and hit['http_referer']:
                    referers += 1

            if isRobot:
                super_hit['robot'] = 1
                continue

            if not super_hit['viewed_pages'] and \
                    (super_hit['viewed_hits'] and not referers):
                super_hit['robot'] = 1
                continue
